/*
 * Copyright (c) 1983 Regents of the University of California.
 * All rights reserved.  The Berkeley software License Agreement
 * specifies the terms and conditions for redistribution.
 */

#ifndef lint
static char sccsid[] = "@(#)get_addrs.c	5.2 (Berkeley) 3/13/86";
#endif not lint

#include "talk_ctl.h"
#include <sys/param.h>
#include <netdb.h>

get_addrs(my_machine_name, his_machine_name)
	char *my_machine_name, *his_machine_name;
{
	struct hostent *hp;
	struct servent *sp;

	msg.pid = htonl(getpid());
	/* look up the address of the local host */
	hp = gethostbyname(my_machine_name);
	if (hp == (struct hostent *) 0) {
		static struct hostent my_def;
		static struct in_addr my_defaddr;
#ifdef BSD4_3
		static char *my_alist[1];
#endif
		static char my_namebuf[128];
		int inet_addr();

		my_defaddr.s_addr = inet_addr(my_machine_name);
		if (my_defaddr.s_addr == -1) {
			fprintf(stderr,
			    "talk: %s: Can't figure out network address.\n",
			    my_machine_name);
			exit(-1);
		}
		strcpy(my_namebuf, my_machine_name);
		my_def.h_name = my_namebuf;
#ifdef BSD4_3
		my_def.h_addr_list = my_alist,
#endif
		my_def.h_addr = (char *)&my_defaddr;
		my_def.h_length = sizeof (struct in_addr);
		my_def.h_addrtype = AF_INET;
		my_def.h_aliases = 0;
		hp = &my_def;
	}
	bcopy(hp->h_addr, (char *)&my_machine_addr, hp->h_length);
	/*
	 * If the callee is on-machine, just copy the
	 * network address, otherwise do a lookup...
	 */
	if (strcmp(his_machine_name, my_machine_name)) {
		hp = gethostbyname(his_machine_name);
		if (hp == (struct hostent *) 0 ) {
			static struct hostent his_def;
			static struct in_addr his_defaddr;
#ifdef BSD4_3
			static char *his_alist[1];
#endif
			static char his_namebuf[128];
			int inet_addr();

			his_defaddr.s_addr = inet_addr(his_machine_name);
			if (his_defaddr.s_addr == -1) {
				fprintf(stderr,
				    "talk: %s: Can't figure out network address.\n",
				    his_machine_name);
				exit(-1);
			}
			strcpy(his_namebuf, his_machine_name);
			his_def.h_name = his_namebuf;
#ifdef BSD4_3
			his_def.h_addr_list = his_alist,
#endif
			his_def.h_addr = (char *)&his_defaddr;
			his_def.h_length = sizeof (struct in_addr);
			his_def.h_addrtype = AF_INET;
			his_def.h_aliases = 0;
			hp = &his_def;
		}
		bcopy(hp->h_addr, (char *) &his_machine_addr, hp->h_length);
	} else
		his_machine_addr = my_machine_addr;
	/* find the server's port */
	sp = getservbyname("ntalk", "udp");
	if (sp == 0) {
		fprintf(stderr, "talk: %s/%s: service is not registered.\n",
		     "ntalk", "udp");
		exit(-1);
	}
	daemon_port = sp->s_port;
}
